#ifdef O3_WITH_GLUE
#pragma warning( disable : 4100)
#pragma warning( disable : 4189)
namespace o3 {


Trait* cXmlDocument::select()
{
   return clsTraits();
}

Trait* cXmlDocument::clsTraits()
{
      static Trait TRAITS[] = {
         {      0,      Trait::TYPE_BEGIN,      "cXmlDocument",       0,                    0,              0,      cXmlNode::clsTraits()  },
         {      0,      Trait::TYPE_GET,        "cXmlDocument",       "documentElement",    clsInvoke,      0,      0                  },
         {      1,      Trait::TYPE_FUN,        "cXmlDocument",       "createElement",      clsInvoke,      1,      0                  },
         {      2,      Trait::TYPE_FUN,        "cXmlDocument",       "createTextNode",     clsInvoke,      2,      0                  },
         {      3,      Trait::TYPE_FUN,        "cXmlDocument",       "createComment",      clsInvoke,      3,      0                  },
         {      4,      Trait::TYPE_FUN,        "cXmlDocument",       "createCDATASection", clsInvoke,      4,      0                  },
         {      5,      Trait::TYPE_FUN,        "cXmlDocument",       "createAttribute",    clsInvoke,      5,      0                  },
         {      6,      Trait::TYPE_FUN,        "cXmlDocument",       "getElementsByTagName",clsInvoke,      6,      0                  },
         {      7,      Trait::TYPE_FUN,        "cXmlDocument",       "getElementById",     clsInvoke,      7,      0                  },
         {      8,      Trait::TYPE_FUN,        "cXmlDocument",       "importNode",         clsInvoke,      8,      0                  },
         {      9,      Trait::TYPE_FUN,        "cXmlDocument",       "setProperty",        clsInvoke,      9,      0                  },
         {      0,      Trait::TYPE_END,        "cXmlDocument",       0,                    0,              0,      0                  },
      };

      return TRAITS;
}

Trait* cXmlDocument::extTraits()
{
      static Trait TRAITS[] = {
         {      0,      Trait::TYPE_BEGIN,      "cXmlDocument",       0,                    0,              0,      0                  },
         {      0,      Trait::TYPE_END,        "cXmlDocument",       0,                    0,              0,      0                  },
      };

      return TRAITS;
}

siEx cXmlDocument::clsInvoke(iScr* pthis, iCtx* ctx, int index, int argc,
           const Var* argv, Var* rval)
{
      siEx ex;
      cXmlDocument* pthis1 = (cXmlDocument*) pthis;

      switch(index) {
         case 0:
            if (argc != 0)
               return o3_new(cEx)("Invalid argument count. ( documentElement )");
            *rval = siXmlElement2(pthis1->documentElement(ctx));
            break;
         case 1:
            if (argc != 1)
               return o3_new(cEx)("Invalid argument count. ( createElement )");
            *rval = siXmlElement2(pthis1->createElement(ctx,argv[0].toStr()));
            break;
         case 2:
            if (argc != 1)
               return o3_new(cEx)("Invalid argument count. ( createTextNode )");
            *rval = siXmlText2(pthis1->createTextNode(ctx,argv[0].toStr()));
            break;
         case 3:
            if (argc != 1)
               return o3_new(cEx)("Invalid argument count. ( createComment )");
            *rval = siXmlComment2(pthis1->createComment(ctx,argv[0].toStr()));
            break;
         case 4:
            if (argc != 1)
               return o3_new(cEx)("Invalid argument count. ( createCDATASection )");
            *rval = siXmlCDATASection2(pthis1->createCDATASection(ctx,argv[0].toStr()));
            break;
         case 5:
            if (argc != 1)
               return o3_new(cEx)("Invalid argument count. ( createAttribute )");
            *rval = siXmlAttr2(pthis1->createAttribute(ctx,argv[0].toStr()));
            break;
         case 6:
            if (argc != 1)
               return o3_new(cEx)("Invalid argument count. ( getElementsByTagName )");
            *rval = siXmlNodeList2(pthis1->getElementsByTagName(ctx,argv[0].toStr()));
            break;
         case 7:
            if (argc != 1)
               return o3_new(cEx)("Invalid argument count. ( getElementById )");
            *rval = siXmlElement2(pthis1->getElementById(ctx,argv[0].toStr()));
            break;
         case 8:
            if (argc != 2)
               return o3_new(cEx)("Invalid argument count. ( importNode )");
            *rval = siXmlNode2(pthis1->importNode(ctx,siXmlNode2 (argv[0].toScr()),argv[1].toBool()));
            break;
         case 9:
            if (argc != 2)
               return o3_new(cEx)("Invalid argument count. ( setProperty )");
            *rval = pthis1->setProperty(argv[0].toStr(),argv[1].toStr());
            break;
      }
      return ex;
}

siEx cXmlDocument::extInvoke(iScr* pthis, iCtx* ctx, int index, int argc,
           const Var* argv, Var* rval)
{
      siEx ex;
      return ex;
}

}
#endif
#pragma warning(default : 4100)
#pragma warning(default : 4189)
