#ifdef O3_WITH_GLUE
#pragma warning( disable : 4100)
#pragma warning( disable : 4189)
namespace o3 {


Trait* cXmlElement::select()
{
   return clsTraits();
}

Trait* cXmlElement::clsTraits()
{
      static Trait TRAITS[] = {
         {      0,      Trait::TYPE_BEGIN,      "cXmlElement",        0,                    0,              0,      cXmlNode::clsTraits()  },
         {      0,      Trait::TYPE_FUN,        "cXmlElement",        "selectSingleNode",   clsInvoke,      0,      0                  },
         {      1,      Trait::TYPE_FUN,        "cXmlElement",        "selectNodes",        clsInvoke,      1,      0                  },
         {      2,      Trait::TYPE_GET,        "cXmlElement",        "tagName",            clsInvoke,      2,      0                  },
         {      3,      Trait::TYPE_FUN,        "cXmlElement",        "getAttribute",       clsInvoke,      3,      0                  },
         {      4,      Trait::TYPE_FUN,        "cXmlElement",        "setAttribute",       clsInvoke,      4,      0                  },
         {      5,      Trait::TYPE_FUN,        "cXmlElement",        "removeAttribute",    clsInvoke,      5,      0                  },
         {      6,      Trait::TYPE_FUN,        "cXmlElement",        "getAttributeNode",   clsInvoke,      6,      0                  },
         {      7,      Trait::TYPE_FUN,        "cXmlElement",        "setAttributeNode",   clsInvoke,      7,      0                  },
         {      8,      Trait::TYPE_FUN,        "cXmlElement",        "removeAttributeNode",clsInvoke,      8,      0                  },
         {      9,      Trait::TYPE_FUN,        "cXmlElement",        "getElementsByTagName",clsInvoke,      9,      0                  },
         {      10,     Trait::TYPE_FUN,        "cXmlElement",        "getElementById",     clsInvoke,      10,     0                  },
         {      11,     Trait::TYPE_FUN,        "cXmlElement",        "normalize",          clsInvoke,      11,     0                  },
         {      0,      Trait::TYPE_END,        "cXmlElement",        0,                    0,              0,      0                  },
      };

      return TRAITS;
}

Trait* cXmlElement::extTraits()
{
      static Trait TRAITS[] = {
         {      0,      Trait::TYPE_BEGIN,      "cXmlElement",        0,                    0,              0,      0                  },
         {      0,      Trait::TYPE_END,        "cXmlElement",        0,                    0,              0,      0                  },
      };

      return TRAITS;
}

siEx cXmlElement::clsInvoke(iScr* pthis, iCtx* ctx, int index, int argc,
           const Var* argv, Var* rval)
{
      siEx ex;
      cXmlElement* pthis1 = (cXmlElement*) pthis;

      switch(index) {
         case 0:
            if (argc < 1 && argc > 2)
               return o3_new(cEx)("Invalid argument count. ( selectSingleNode )");
            *rval = siXmlNode2(pthis1->selectSingleNode(ctx,argv[0].toStr(),argc > 1 ? argv[1].toScr() : 0));
            break;
         case 1:
            if (argc < 1 && argc > 2)
               return o3_new(cEx)("Invalid argument count. ( selectNodes )");
            *rval = siXmlNodeArray2(pthis1->selectNodes(ctx,argv[0].toStr(),argc > 1 ? argv[1].toScr() : 0));
            break;
         case 2:
            if (argc != 0)
               return o3_new(cEx)("Invalid argument count. ( tagName )");
            *rval = pthis1->tagName();
            break;
         case 3:
            if (argc != 1)
               return o3_new(cEx)("Invalid argument count. ( getAttribute )");
            *rval = pthis1->getAttribute(ctx,argv[0].toStr());
            break;
         case 4:
            if (argc != 2)
               return o3_new(cEx)("Invalid argument count. ( setAttribute )");
            pthis1->setAttribute(ctx,argv[0].toStr(),argv[1].toStr());
            break;
         case 5:
            if (argc != 1)
               return o3_new(cEx)("Invalid argument count. ( removeAttribute )");
            pthis1->removeAttribute(ctx,argv[0].toStr());
            break;
         case 6:
            if (argc != 1)
               return o3_new(cEx)("Invalid argument count. ( getAttributeNode )");
            *rval = siXmlAttr2(pthis1->getAttributeNode(ctx,argv[0].toStr()));
            break;
         case 7:
            if (argc != 1)
               return o3_new(cEx)("Invalid argument count. ( setAttributeNode )");
            *rval = siXmlAttr2(pthis1->setAttributeNode(ctx,siXmlAttr2 (argv[0].toScr()),&ex));
            break;
         case 8:
            if (argc != 1)
               return o3_new(cEx)("Invalid argument count. ( removeAttributeNode )");
            *rval = siXmlAttr2(pthis1->removeAttributeNode(siXmlAttr2 (argv[0].toScr())));
            break;
         case 9:
            if (argc != 1)
               return o3_new(cEx)("Invalid argument count. ( getElementsByTagName )");
            *rval = siXmlNodeList2(pthis1->getElementsByTagName(argv[0].toStr()));
            break;
         case 10:
            if (argc != 1)
               return o3_new(cEx)("Invalid argument count. ( getElementById )");
            *rval = siXmlElement2(pthis1->getElementById(ctx,argv[0].toStr()));
            break;
         case 11:
            if (argc != 0)
               return o3_new(cEx)("Invalid argument count. ( normalize )");
            pthis1->normalize(ctx);
            break;
      }
      return ex;
}

siEx cXmlElement::extInvoke(iScr* pthis, iCtx* ctx, int index, int argc,
           const Var* argv, Var* rval)
{
      siEx ex;
      return ex;
}

}
#endif
#pragma warning(default : 4100)
#pragma warning(default : 4189)
